<?php
/*
Plugin Name: More fields 
Version: 0.6
Author URI: http://henrikmelin.se
Plugin URI: http://labs.dagensskiva.com/
Description:  Adds any number of extra fields (text, textareas and selects), in any number of additional boxes in the admin. Get the data by do_action('more_fields', 'Name of box');
Author: Henrik Melin, Kal Ström

	USAGE:

	See http://labs.dagensskiva.com/plugins/more-fields/

	LICENCE:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    
*/



function p2m_meta_box_settings() {

	// These are options associate with each field
	$p2m_fid = array('key_', 'title_','type_', 'select_values_');
	// These are settings associated with each box
	$p2m_oth = array('page_', 'post_', 'name_', 'position_');

	// Saving our Options.
	if ($_POST['action'] == 'update') {

		$more_fields = array();

		$b = 0;
		while (array_key_exists('name_' . $b,  $_POST)) {
			update_option('more_fields_hide_related', $_POST['hide_related']);
		
			$box = $_POST['name_' . $b];
			$more_fields[$box]['on_post'] = $_POST['post_' . $b];
			$more_fields[$box]['on_page'] = $_POST['page_' . $b];
			$more_fields[$box]['position'] = $_POST['position_' . $b]; // == 'on') ? 'left' : 'right';
			$more_fields[$box]['name'] = $box;

			// Iterate through the fields
			$f = 0;
			while (array_key_exists('key_' . $b . '_' . $f,  $_POST)) {
				$key   = $_POST['key_' . $b . '_' . $f];
				$title = $_POST['title_' . $b . '_' . $f];
				$type  = $_POST['type_' . $b . '_' . $f];
				$select_values = $_POST['select_values_' . $b . '_' . $f];
				$more_fields[$box]['field'][$f] = 
					array('title' => $title, 'type' => $type, 'key' => $key, 'select_values' => $select_values);
				$f++;			
			}
			$b++;			
		}
		
		update_option('more_fields_boxes', $more_fields);
		echo '<div id="message" class="updated fade"><p><strong>' . __('Options saved.', 'more-fields') . '</strong></p></div>';


	}
	
	?>
	
		<link rel="stylesheet" href="<?php echo $url = get_option('siteurl') . '/' . PLUGINDIR . '/' . dirname(plugin_basename (__FILE__)); ?>/more-fields.css" type="text/css" /> 	
		<div class="wrap">
 			<h2>More Fields - <?php _e('Administration', 'more-fields'); ?>	</h2>
			
			<p><?php _e('Here you can create boxes on the Write/Edit pages (for both Posts and Pages) containing fields that add value to your text. See <a href="http://labs.dagensskiva.com/plugins/more-fields/">some examples</a>. These fields will be stored as custom fields with the key specified for each field.', 'more-fields'); ?></p>

			<p><?php _e('Each key must be unique.', 'more-fields'); ?></p>

			<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo basename(__FILE__); ?>">

			<p>
				<input class="button" type="button" onclick="mf_add_box(); return false;" value="<?php _e('Add new box!', 'more-fields'); ?>" /> <h5>(<?php _e('New boxes will appear at the bottom of the page', 'more-fields'); ?>)</h5>
			</p>	
			<p class="submit">			
				<input class="button" type="submit" name="Submit" value="<?php _e('Save Settings', 'more-fields') ?>" />	
			</p>

			
			
			<br />
			<!--hr -->
			<div id="boxes_div">
				<?php
				
					$more_fields = get_option('more_fields_boxes');
//					echo '<pre>';
//					print_r($more_fields);
//					echo '</pre>';
					p2m_meta_box(0);				
					for ($i = 1; $i < count($more_fields); $i++) p2m_meta_box($i);				
				
				?>
			</div>
			
			
			<?php if (is_callable('do_meta_boxes')) : ?>
			<table class="form-table">
				 <tr>
 					<th scope="row" valign="top"><?php _e('General options', 'more-fiels'); ?>:</th>
 					<td>
 						<label><input type="checkbox" name="hide_related" <?php if (get_option('more_fields_hide_related') == 'on') echo ' checked="checked"'; ?>> <?php _e('Remove \'Related\' links on Write/Edit page', 'more-fields'); ?>
 					</td>
 				</tr>					
			</table>
			<?php endif; ?>
			
			<input type="hidden" name="action" value="update" />
			<input type="hidden" name="page_options" id="page_options" value="" />

			<p class="submit">			
				<input class="button" type="submit" name="Submit" value="<?php _e('Save Settings', 'more-fields') ?>" />
			</p>
		</form>
	</div>
</div>

<?php

}

/**
***  p2m_meta_field (  )
***  p2m_meta_get_field (  )
***
**/
function p2m_meta_field($wnbr = 1, $wnbr = 1, $field = array()) { echo p2m_meta_get_field($wnbr, $nbr, $field); }
function p2m_meta_get_field($wnbr, $nbr, $field = array()) {

	$defaults = array('title' => '', 'type' => 'text', 'key' => '', 'select_values' => '');
	$field = wp_parse_args($field, $default);
		
	$html = '
		<table id="box_field_div_%wnbr%_%nbr%" class="fields">
			<tr>
				<td class="fieldKey"><label for="title_%wnbr%_%nbr%">' . __('Key', 'more-fields') . ' %nbr%: </label></td>
				<td class="fieldkey-value"><input type="text" class="field" name="key_%wnbr%_%nbr%" id="key_%wnbr%_%nbr%" value="%key%"></td>
				<td class="fieldTitle"><label for="title_%wnbr%_%nbr%"> ' . __('Title', 'more-fields') . ' %nbr%: </label></td>
				<td class="fieldTitle-value"><input type="text" class="field" name="title_%wnbr%_%nbr%" id="title_%wnbr%_%nbr%" value="%title%"></td>
				<td class="fieldType"><label class="field"> ' . __('Type', 'more-fields') . ' %nbr%: </label></td>
				<td class="fieldType-value"><select class="where" name="type_%wnbr%_%nbr%" id="type_%wnbr%_%nbr%" onchange="if (this.value == \'select\') $(\'select_values_div_%wnbr%_%nbr%\').show(); else $(\'select_values_div_%wnbr%_%nbr%\').hide();"><option value="text" %is_text%>Text</option><option value="textarea" %is_textarea%>Text area</option><option value="select" %is_select%>Select list</option></select></td>
				<td class="fieldActions">		
					<a href="#" onclick="mf_remove(%wnbr%,%nbr%); return false;">' . __('Remove', 'more-fields') . '</a> | 
					<a href="#" onclick="mf_move_up(%wnbr%, %nbr%); return false;">' . __('Move up', 'more-fields') . '</a> |
					<a href="#" onclick="mf_move_down(%wnbr%,%nbr%); return false;">' . __('Move down', 'more-fields') . '</a> 
				</td>
			</tr>
			<tr id="select_values_div_%wnbr%_%nbr%" %sv_style%>
				<td></td>
				<td colspan="5" class="fieldValues">
					<input class="field_select_values" name="select_values_%wnbr%_%nbr%" id="select_values_%wnbr%_%nbr%" type="text" value="%select_values%">			
				</td>
			</tr>
		</table>
		';			
		
	$html = str_replace('%nbr%', $nbr, $html);
	$html = str_replace('%wnbr%', $wnbr, $html);
	$html = str_replace('%wpid%', $wnbr + '_' + $nbr, $html);

	$html = str_replace('%key%', $field['key'], $html);

	// Cosmetize
	$title = stripslashes(wptexturize($field['title']));
	$html = str_replace('%title%', $title, $html);
	$select_values = format_to_edit($field['select_values']);
	$html = str_replace('%select_values%', $select_values, $html);
	

	$html = str_replace('%sv_style%', ($field['type'] != 'select') ? ' style="display: none;"' : '', $html);
	

	// Position select
	$html = str_replace('%is_text%', ($field['type'] == 'text') ? 'selected="selected"' : '', $html);
	$html = str_replace('%is_textarea%', ($field['type'] == 'textarea') ? 'selected="selected"' : '', $html);
	$html = str_replace('%is_select%', ($field['type'] == 'select') ? 'selected="selected"' : '', $html);



	return $html;
}
/**
***  p2m_meta_get_box ( )
***  p2m_meta_box ( )
***
**/
function p2m_meta_box($wnbr = 1) { echo p2m_meta_get_box($wnbr); }
function p2m_meta_get_box($wnbr) {
	
	// Get values for this box
	$more_fields = mf_get_boxes();
	$more_fields_keys = (is_array($more_fields)) ? array_keys($more_fields) : array();
	$box = $more_fields[$more_fields_keys[$wnbr]];
	
	$html = '
		<div id="box_div_%wnbr%">
		<hr style="display: none;">
		<div class="box_header">
			<div class="box_name">
				' . __('Name of box', 'more-fields') . ' <br />
				<input class="box_name" type="text" name="name_%wnbr%" id="name_%wnbr%" value="%name%" onchange="mf_check_for_duplicates(%wnbr%)" /> 
			</div>
			<div class="box_position">' . __('Position', 'more-fields') . ' <br /><select name="position_%wnbr%" id="position_%wnbr%"><option value="right" %is_right%>' . __('Right', 'more-fields') . '</option><option value="left" %is_left%>' . __('Left', 'more-fields') . '</option></select></div>
			<div class="box_options">
				<label class="field_entry"><input id="post_%wnbr%" type="checkbox" name="post_%wnbr%" %is_post% /> ' . __('Include on Post Write/Edit', 'more-fields') . '</label>
				<label class="field_entry"><input id="page_%wnbr%" type="checkbox" name="page_%wnbr%" %is_page% /> ' . __('Include on Page Write/Edit', 'more-fields') . '</label>
			</div>
		</div>
		<div id="box_fields_div_%wnbr%" class="box_fields">	
	';


	$html = str_replace('%position%', $position, $html);

	// Now create the fields for this box	
	$field_counter = 0;
	if (!isset($box['field'][0])) $box['field'][0] = array();
	$html .= p2m_meta_get_field($wnbr, $field_counter++, $box['field'][0]);
	for ($i = 1; $i < count($box['field']); $i++) {
		$html .= p2m_meta_get_field($wnbr, $field_counter++, $box['field'][$i]);	
	}

	$html .= '</div>
	<div style="background: #335533; padding: 10px; margin-bottom: 20px;">
		<div style="float: right;">
			<a href="#" style="color: #ffffff;" onclick="mf_delete_box(%wnbr%); return false;"> ' . __('Delete this box', 'more-fields') . '</a>
		</div>
		<div>
			<a href="#" onclick="mf_add_field('.$wnbr.'); return false;" style="color: #ffffff;">' . __('Add new field!', 'more-fields') . '</a>
		</div>	
	
	</div>';

	
	// Template variable replace
	$html = str_replace('%wnbr%', $wnbr, $html);
	$html = str_replace('%name%', $more_fields_keys[$wnbr], $html);

	// Position select
	$html = str_replace('%is_right%', ($box['position'] == 'right') ? 'selected="selected"' : '', $html);
	$html = str_replace('%is_left%', ($box['position'] == 'left') ? 'selected="selected"' : '', $html);

	// Options
	$html = str_replace('%is_post%', ($box['on_post'] == 'on') ? 'checked="checked"' : '', $html);
	$html = str_replace('%is_page%', ($box['on_page'] == 'on') ? 'checked="checked"' : '', $html);


	$html .= '<!-- h r --></div>';
	return $html;
}

function more_fields_ui_select ($select_values, $value = '', $key = '') {
	global $post;
	echo '<option value=""></option>';	
	$parts = explode(',', $select_values);
	for ($i=0; $i<count($parts); $i++) {
		foreach (explode(':', $parts) as $part) {
			$range = explode(':', $parts[$i]);
			// If an integer is specified, as e.g. 1:10, then produce that range
			if (count($range) > 1) {
				if ($range[0] < $range[1]) {
					for ($j = $range[0]; $j <= $range[1]; $j++) {
						$selected = ($j == $value) ? ' selected="selected"' : '';
						echo '<option value="' . htmlspecialchars($j) . '"'.$selected.'>' . $j . '</option>';								
					}
				} else {
					for ($j = $range[0]; $j >= $range[1]; $j--) {
						$selected = ($j == $value) ? ' selected="selected"' : '';
						echo '<option value="' . htmlspecialchars($j) . '"' . $selected.'>' . $j . '</option>';								
					}									
				}
			} else {

				// Format and trim
				$option_raw = ($parts[$i]);
				//$value = htmlspecialchars($value);
				$option_raw = ltrim(rtrim($option_raw));

				// Remove syntax for defining the default value
				if (strstr($option_raw, '*')) $option = substr($option_raw, 1);
				else $option = $option_raw;

				// Only apply defaults if nothing is saved
				$meta_data = get_post_custom($post->ID);
				if (!is_array($meta_data)) $meta_data = array();
				if (!array_key_exists($key, $meta_data))
					$selected = ($option != $option_raw) ? ' selected="selected"' : '';
				else $selected = ($option == $value) ? ' selected="selected"' : '';

				// Create the selec value
				echo '<option value="' . format_to_edit($option) . '"'.$selected.'>' . $option . '</option>';
			}
		}
	}
}





/**
***  p2m_meta_box_save (  )
**/
function p2m_meta_box_save($post_id, $post) {
    global $wpdb, $post;

	if (!$post_id) $post_id = $_POST['post_ID'];
	if (!$post_id) return $post;

	$more_fields = mf_get_boxes();

	// Watch me being very defensive.
	foreach ($more_fields as $box) {
		foreach($box['field'] as $field) {
			$key = $field['key'];
			if (array_key_exists($key, $_POST)) {
				$value = stripslashes($_POST[$key]);
				// If the value changed...
				if ($value || (!$value && get_post_meta($post_id, $key, true)))
					if ($value != get_post_meta($post_id, $key, true)) 
						if (!add_post_meta($post_id, $key, $value, true)) 
							update_post_meta($post_id, $key, $value);	
			}
		}	
	}
    return $post;
}

/**
***  get_box (  )
**/
function get_box  ($name, $args = array()) {
    global $post;
    $html = '';
    $nl = "\n";

	// Get our fields
	$more_fields = mf_get_boxes();

	// Parse args
	$defaults = array('format' => 'ul', 'div' => '', 'show' => '', 'title' => '');
	$args = wp_parse_args($args, $defaults);

	if (!is_array($more_fields)) return '<!-- No More Fields are defined -->';
	if (!array_key_exists($name, $more_fields)) return "<!-- The box name '$name' does not exist! -->";

	// Make sure we've got someting to display
	$someting = false;
	foreach ($more_fields[$name]['field'] as $field) 
		if (get_post_meta($post->ID, $field['key'], true)) $something = true;
	if (!$something) return "<!-- Nothing to display for '$name' -->";

	// Iterate through our meta fields and generat some html
	for ($i=0; $i < count($more_fields[$name]['field']); $i++) {
		$key = $more_fields[$name]['field'][$i]['key'];
		$title = $more_fields[$name]['field'][$i]['title'];		

		// Set up the list
		if ($i == 0) {
			if ($args['div']) $html .= '<div id="' . $args['div'] .'">' . $nl;
			if ($args['format']) {
				$caption = ($args['title']) ? ($args['title']) : $name;
				$html .= '<h3 class="meta_widget_header">' . $caption . '</h3>' . $nl;
				$html .= '<' . $args['format'] . '>' . $nl;
			}
		}
		// Does this field qualify for being shown?
		$show = false;
		if (is_array($args['show'])) {
			for ($k = 0; $k < count($args['show']); $k++) 
				if ($args['show'][$k] == $key)
					$show =  true;
		} else if (!$args['show'] || ($args['show'] == $key)) $show = true;

		if ($show) {

			// Amost the same as 'the_content' filter
			$value = get_post_meta($post->ID, $key, true);
			$value = preg_replace("/\n/", "<br />", $value);
			$value = wptexturize($value);
			$value = convert_chars($value);
			
			$style_li = ' class="meta_' . $key . '_ul"';
			$style_dt = ' class="meta_' . $key . '_dt"';
			$style_dd = ' class="meta_' . $key . '_dd"';
			if ($args['format'] == 'ul') $html .= "<li ${style_li}>" . $value . '</li>' . $nl;
			else if ($args['format'] == 'dl') $html .= "<dt ${style_dt}>" . $title . "</dt><dd ${style_dd}>" . $value . '</dd>' . $nl;
			else if ($args['format'] == 'p') $html .= $value . $nl;
			else $html .= $value . $nl;
		}
		// Close the list and the optional div
		if ($i == count($more_fields[$name]['field']) - 1) {
			if ($args['format']) $html .= '</' . $args['format'] . '>' . $nl;
			if ($args['div']) $html .= '</div>' . $nl;
		}
	}
    echo $html;
}

/*
**   get_meta ( )
**
*/
function get_meta ($meta, $id = '') {	
	global $post;
	if ($id) $meta = get_post_meta($id, $meta, true);
	else {
		$id = (get_the_id()) ? get_the_id() : $post->ID;
		$meta = get_post_meta($id, $meta, true);
	}
	return $meta;
}
function meta ($meta, $id = '') { echo get_meta($meta, $id); }


function mf_get_boxes() {
	global $more_fields_boxes;
	$more_fields = get_option('more_fields_boxes');
	if (!is_array($more_fields)) $more_fields = array();
	if (!is_array($more_fields_boxes)) $more_fields_boxes = array();
	
	foreach (array_keys($more_fields_boxes) as $key)
		$more_fields[$key] = $more_fields_boxes[$key];
	return $more_fields;
}

/*

// DEVSTUFF

function mf_add_meta_box($id, $title, $fields, $context = '', $position = '') {
	global $more_fields_boxes;
	$on_post = ($context == 'post' || !$context) ? true : false;
	$on_page = ($context == 'page' || !$context) ? true : false;	
	$box = array('name' => $title, 'on_post' => $on_post, 'on_page' => $on_page, 'position' => $position);
	$box['field'] = $fields;
	$more_fields_boxes[$id]	= $box;
}



$fields = array(
	array('key' => 'artist', 'title' => __('Titel'), 'type' => 'text'),
	array('key' => 'label', 'title' => __('Label'), 'type' => 'select', 'select_values' => 'hej, *henrik'),
);

mf_add_meta_box('foo', __('Foo'), $fields);
*/


/**
***  dsc_admin_pages (  )
**/
function p2m_admin_pages() {
	add_options_page('More Fields', 'More Fields', 8, basename(__FILE__), 'p2m_meta_box_settings');
}


/*
**		p2m_translate ( )
**
*/
function mf_translate(){
    // Load a language
	load_plugin_textdomain('more-fields', PLUGINDIR . '/' . dirname(plugin_basename (__FILE__)) );
}
add_action('init', 'mf_translate'); 

// Hook for adding admin menus
add_action('admin_menu', 'p2m_admin_pages');
add_action('save_post', 'p2m_meta_box_save', 11, 2);
add_action('save_page', 'p2m_meta_box_save', 11, 2);
add_action('publish_post', 'p2m_meta_box_save', 11, 2);
add_action('publish_page', 'p2m_meta_box_save', 11, 2);


/*
**    more_fields_template_action ()
**
**    Remplate action to get content of a box.
*/
function more_fields_template_action ($title, $options = array()) {
	get_box($title, $options);		
}
add_action('more_fields', 'more_fields_template_action', 10, 2);

function mf_ua_callback($object, $box) {
	$more_fields = mf_get_boxes();
	mf_build_gut($more_fields[$box['title']]);	
}

function mf_build_gut($box) {
	global $post;

	do_action('mf_box_head', $box);

	foreach ($box['field'] as $field) {
		if (!($field = apply_filters('mf_field', $field))) continue;

		$value = get_post_meta($post->ID, $field['key'], true);
		echo '<p>';
		if ($field['title']) 
			echo '<label class="mf_label_' . $box['position'] . '" for="' . $field['key'] . '">' . $field['title'] . ':</label>';
		
		if ($field['type'] == 'text') {
			if ($field['title']) {
				echo '<input class="mf_text_' . $box['position'] . '" name="' . $field['key'] . '" id="' . $field['key'] . '" type="text" value="' . $value . '">';
				echo '<br />';
			} else echo '<input class="mf_text_' . $box['position'] . '" name="' . $field['key'] . '" id="' . $field['key'] . '" type="text" value="' . $value . '">';
		} else if ($field['type'] == 'textarea') {
			if ($field['title']) {
				echo '<textarea name="' . $field['key'] . '"  class="mf_textarea_' . $box['position'] . '">' . $value . '</textarea>';
			} else echo '<textarea class="mf_textarea_' . $box['position'] . '">' . $value . '</textarea>';				
		} else if ($field['type'] == 'select') {
			echo '<select class="mf_select_' . $box['position'] . '" id="' . $field['key'] . '" name="' . $field['key'] . '">'	;
			more_fields_ui_select($field['select_values'], $value);
			echo '</select>';
		}		
		echo '</p>';
	}	
	do_action('mf_box_foot', $box);
}

function mf_allow($box) {
	// Allow user to change the visibility of a box, e.g. based on user level.
	$is_post = preg_match("/\/post/", $_SERVER['PHP_SELF']);
	$is_page = preg_match("/\/page/", $_SERVER['PHP_SELF']);
	if ($is_page && $box['on_page'] == 'on') return true;
	else if ($is_post && $box['on_post'] == 'on') return true;
	else return false;
}

/*
function mf_build_left_boxes() {
	$more_fields = mf_get_boxes();
	foreach ($more_fields as $box) {
		if (mf_allow($box) && $box['position'] == 'left') {
			echo '<div id="' . $box['name'] . '" class="postbox ' . postbox_classes($box['name'], $page) . '">' . "\n";
			echo "<h3>{$box['name']}</h3>\n";
			echo '<div class="inside">' . "\n";
			mf_build_gut($box);
			echo "</div>\n";
			echo "</div>\n";
		}
	}
}

add_action('edit_form_advanced', 'mf_build_left_boxes');		

*/

function mf_build_right_boxes() {
	$more_fields = mf_get_boxes();
	foreach ($more_fields as $box) {
		if (!($box = apply_filters('mf_box', $box))) continue;
		if (mf_allow($box) && $box['position'] == 'right') {
			echo '<div style="width: 100%; background: #ffffff; height: 10px;"></div>';
			echo '<div id="' . $box['name'] . '" class="postbox ' . postbox_classes($box['name'], $page) . '"  style="margin: 0px; background: #fff">' . "\n";	
			echo "<h3>{$box['name']}</h3>\n";
			echo '<div class="inside" style="margin: 5px; width: 200px;">' . "\n";
			mf_build_gut($box);
			echo "</div>\n";
			echo "</div>\n";
		}
	}
}

add_action('submitpost_box', 'mf_build_right_boxes'); 

function mf_admin_init() {
	wp_enqueue_script('prototype', false);
	wp_enqueue_script('jquery', false);

	$more_fields = mf_get_boxes();
	
	// Hook the More Fields boxes into the WP meta box framework
	foreach($more_fields as $box) {
		if (!($box = apply_filters('mf_box', $box))) continue;
		// If it's positioned to the right, then add an additional page type, not processed by WP
		$page = ($box['position'] == 'right') ? '_right' : '';
//		$show = (apply_filters('mf_create_box_bool', $box)) ? true : false;
	//	if ($show) {
			if ($box['on_post'])
				add_meta_box($box['name'], $box['name'], 'mf_ua_callback', 'post' . $page, 'normal');
			if ($box['on_page']) 
				add_meta_box($box['name'], $box['name'], 'mf_ua_callback', 'page' . $page, 'normal');
	//	}
	}

}

add_action('admin_init', 'mf_admin_init');


//function mf_return_true ($args, $more_args = '') {
//	return true;
//}

//add_filter('mf_create_box_bool', 'mf_return_true');
//add_filter('mf_create_field_bool', 'mf_return_true', 10, 2);

/*

// Hide the secrets box
function restrict_access_to_box($box) {
	$user = wp_get_current_user();
	if ($box['name'] == 'Secrets') {
		if ($user->user_level < 10) return false;
	}
	return $box;
}

add_filter('mf_box', 'restrict_access_to_box', 11);

// Hide the artist field
function restrict_access_to_field($field) {
	$user = wp_get_current_user();
	if ($field['key'] == 'artist') {
		if ($user->user_level < 10) return false;
	}
	return $field;
}

add_filter('mf_field', 'restrict_access_to_field', 11);
*/



function mf_admin_head() {
	if (preg_match("/\/post/", $_SERVER['PHP_SELF'])) {
		$url = get_settings('siteurl');
		$url = $url . '/wp-content/plugins/' . basename(dirname(__FILE__)) . '/more-fields.css';
		echo "\n" . '<link rel="stylesheet" type="text/css" href="' . $url . '" />' . "\n";
	}
}
add_action('admin_head', 'mf_admin_head');


function mf_admin_options_head() {
	$siteurl = get_settings('siteurl');
	$url = $siteurl . '/wp-content/plugins/' . basename(dirname(__FILE__)) . '/more-fields-options.css';
	echo '<link rel="stylesheet" type="text/css" href="' . $url . '" />'. "\n";
	$url = $siteurl . '/wp-content/plugins/' . basename(dirname(__FILE__)) . '/more-fields-js.php';
	echo "<script type='text/javascript' src='$url'></script>\n";
}

add_action('admin_head-' . sanitize_title(__('Inställningar')) .  '_page_more-fields', 'mf_admin_options_head');



// settings_page_more-fields for JS

function mf_queue_js () {
//	wp_enqueue_script('mf_js', $path, 'jquery');
}

add_action('load-options_more-fields', 'mf_queue_js');

function mf_load_js () {
// ADD THE CSS FOR THE SETTIGNS PAGE
	$url = get_settings('siteurl');
	$url = $url . '/wp-content/plugins/more-fields/more-fields.css';
	echo '<link rel="stylesheet" type="text/css" href="' . $url . '" />';
}

//add_action('load-settings_page_more-fields', 'mf_load_js');
add_action('admin_head-settings_page_more-fields', 'mf_load_js');


function mf_admin_foot () {
	if (get_option('more_fields_hide_related') == 'on') {
		echo '<script language="JavaScript" type="text/javascript">' . "\n";
		echo 'jQuery(".side-info").remove();' . "\n";
		echo '</script>' . "\n";
	}
}

add_action('admin_footer', 'mf_admin_foot');



/*******************************************************
********************************************************
*****
*****	   PRE 2.5 BACKWARD COMPATABILITY BELOW
*****
*****
****/

function p2m_meta_box_build_ui () {
	if (!function_exists('add_meta_box')) 
		p2m_meta_box_build_ui_old();
}

add_action('admin_footer', 'p2m_meta_box_build_ui'); 

/**
***  p2m_meta_box_build_ui_old (  )
**/
function p2m_meta_box_build_ui_old() {
	global $wpdb, $post;

	// Where we at?	
	$is_post = preg_match("/\/post/", $_SERVER['PHP_SELF']);
	$is_page = preg_match("/\/page/", $_SERVER['PHP_SELF']);

	$more_fields = mf_get_boxes();
	$more_fields_keys = (is_array($more_fields)) ? array_keys($more_fields) : array();
	
	foreach ($more_fields_keys as $box) {

		if (($more_fields[$box]['on_post'] == 'on' && $is_post) || 
			($more_fields[$box]['on_page'] == 'on' && $is_page)) {
			$header = $more_fields[$box]['name'];
			$where = ($more_fields[$box]['position'] == 'left') ? '_left' : '';
			$div = $p2m_wid . $box.'_div';
			?>
			<style type='text/css'>
				.p2m_title_left { clear: left; }
				.p2m_text_left { width:85%; }
				.p2m_label_left { text-align: right; width: 10%; display: block; float: left; margin-right: 1%; }
				.p2m_text { width: 90%; margin-left: 1px; }
				.p2m_textarea { width: 90%; margin-left: 1px; }
				.p2m_select { width: 100px; }
				.p2m_label { margin-left: 2px; }
			</style>
			<?php

			// Print out the header
			if ($where) echo p2m_box_left_head($header, $div);
			else echo p2m_box_right_head($header, $div);

			do_action('more_fields_admin', $box);

			foreach ($more_fields[$box]['field'] as $field) {
				$value  = (get_post_meta($post->ID, $field['key'], true));

				if (!$where) $cssstyle = ' style="width: 90%;" ';
				else $cssstyle = ' style="width: 100%; oveflow: hidden" ';

				if ($field['title']) 
					echo '<label for="' . $field['key'] . '" class="p2m_label' . $where . '">' . wptexturize($field['title']) . '</label>';

				if ($field['type'] == 'text') {
					?>							
					<input class="p2m_text<?php echo $where; ?>" type='text' size="13" name="<?php echo $field['key']; ?>" id="<?php echo $field['key']; ?>" value="<?php echo htmlspecialchars($value); ?>" />
					<?php 
				} else if ($field['type'] == 'textarea') {
					$cssstyle = '';
					?>	
						<textarea class="p2m_text<?php echo $where; ?>" cols="<?php if (!$where) echo 14; else echo 30; ?>" rows="10" name="<?php echo $field['key']; ?>" id="<?php echo $field['key']; ?>"><?php echo htmlspecialchars($value); ?></textarea>
					<?php 
				} else { 
					if ($where) $cssstyle = ' style="width: 200px;" ';
					echo '<select class="p2m_select' . $where . '" name="' . $field['key'] . '" id="' . $field['key'] . '">';
					more_fields_ui_select($field['select_values'], $value, $field['key']);
					echo '</select><br />';
				}
			}
			?>
			</div>
			<?php if ($where) { 
				$wpdiv = ($is_page) ? 'postcustom' : 'postexcerpt';
			?>
				<!-- /fieldset --!>   
				</div>
				</div>
				</fieldset>
				<script language="JavaScript" type="text/javascript">
					var p = $('<?php echo $wpdiv; ?>');
					var b = $('<?php echo $div; ?>');
					p.parentNode.insertBefore(b, p);
				</script>
			<?php } else { 
				$wpdiv = ($is_page) ? 'commentstatusdiv' : 'categorydiv';
			?>
				</fieldset>
				<!-- /fieldset -->
				<script language="JavaScript" type="text/javascript">
					var p = $('<?php echo $wpdiv; ?>');
					var b = $('<?php echo $div; ?>');
					p.parentNode.insertBefore(b, p);
				</script>		
				<?php
			}
		}
	}
}

function p2m_box_right_head ($title, $id) {
	$html = '
		<fieldset id="%id%" class="dbx-box">
		<h3 class="dbx-handle">%title%</h3>
		<div class="dbx-content">
		';
	$html = str_replace('%title%', $title, $html);
	$html = str_replace('%id%', $id, $html);
	return $html;
}

function p2m_box_right_foot () {
	$html = '
		</div>
		</fieldset>
		';
	return $html;
}

function p2m_box_left_head ($title, $id) {
	$html = '
		<div id="%id%" class="dbx-b-ox-wrapper">
		<fieldset id="postcustom" class="dbx-box">
		<div class="dbx-h-andle-wrapper">
			<h3 class="dbx-handle">%title%</h3>
		</div>
		<div class="dbx-c-ontent-wrapper">
			<div class="dbx-content">		
		';
	$html = str_replace('%title%', $title, $html);
	$html = str_replace('%id%', $id, $html);
	return $html;
}

function p2m_box_left_foot () {
	$html = '
		</div>
		</div>
		</fieldset>
		</div>
		';
	return $html;
}

?>